package it.cs.android123;

import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.net.URI;
import java.net.URISyntaxException;

import org.apache.http.HttpResponse;
import org.apache.http.client.ClientProtocolException;
import org.apache.http.client.HttpClient;
import org.apache.http.client.ResponseHandler;
import org.apache.http.client.methods.HttpGet;
import org.apache.http.impl.client.DefaultHttpClient;

import android.app.Activity;
import android.net.Uri;
import android.os.Bundle;
import android.os.Handler;
import android.os.Message;
import android.text.Editable;
import android.util.Log;
import android.view.View;
import android.webkit.WebView;
import android.widget.Button;
import android.widget.EditText;

public class HttpClientExampleActivity extends Activity {
    /** Called when the activity is first created. */
	private MyResponseHandler responseHandler;
	private EditText editText;
	private WebView webView;
	private Button buttonRequest;
	private Handler myHandler;
	
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.main);
        responseHandler=new MyResponseHandler();
        editText=(EditText)findViewById(R.id.editText1);
        webView=(WebView)findViewById(R.id.webView);
        buttonRequest=(Button)findViewById(R.id.button1);
        myHandler=new Handler() {
        
        	@Override
        	public void handleMessage(Message msg) {
        		webView.loadData((String)msg.obj, "text/html", "ISO 8859-1");
        		buttonRequest.setEnabled(true);
        	}
        };
    }
    
 
    
    public void sendRequest(View v) throws URISyntaxException {
    	
    	String address=editText.getText().toString();
    	buttonRequest.setEnabled(false);
    	if (!address.equals("")) {
    		
    		MyThread httpThread=new MyThread(address);
    		httpThread.start();
   
    	} 
    }
    
   
    public void loadWebPage(String webPage) {
    	webView.loadData(webPage, "text/html", "ISO 8859-1");
    }
    
    
    
    class MyResponseHandler implements ResponseHandler<String> {

		@Override
		public String handleResponse(HttpResponse response) throws ClientProtocolException, IOException {
		
			InputStream content=response.getEntity().getContent();
			byte[] buffer=new byte[1024];
			int numRead=0;
			ByteArrayOutputStream stream=new ByteArrayOutputStream();
			while ((numRead=content.read(buffer))!=-1) 
				stream.write(buffer, 0, numRead);
			content.close();
			String result=new String(stream.toByteArray());
			Message messageToSend = myHandler.obtainMessage();
			messageToSend.obj = result;
			myHandler.sendMessage(messageToSend);
			return result;
		}
    	
    }
    
    
    class MyThread extends Thread {
    	
    	private URI uri;
    	
    	
        public MyThread(String address) throws URISyntaxException {
    	
        	try {
    			uri=new URI(address);
    		} 
    		catch(Exception e) {
    			
    		}
    	}
    	   
        
    	public void run() {
    		HttpClient client=new DefaultHttpClient();
    		HttpGet request=new HttpGet();
    		
    		request.setURI(uri);
    		try {
				client.execute(request, responseHandler);
			} catch (ClientProtocolException e) {
				// TODO Auto-generated catch block
				
				e.printStackTrace();
			} catch (IOException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
    		
    	}
    	
    }
}